/** <p>Informacio dels tokens que es passa entre les diferentes regles.</p>
 * @author Carles Royan Salvatella
 * @version 1.0 - Data: 18/06/2003
 */
class ParamInfo
{
	/** Nom del token */
	private String name;
	/** El text parsejat: normalment nom de la variable, expressio,etc. */
	private String text;
	/** Si la variable es de tipus classe, nom de la classe. */
	private String className;
	/** Si s'ha resolt algun simbol per herencia, indica la classe on esta definit. */
	private String superClassName;
	/** Tipus de ID (tipus_elementals,ref. a classe,funcio,...). */
	private int idType;
	/** Tipus de dada que emmagatzema l'ID (ENTER,REAL,CARACTER,...). */
	private int type;
	/** Dimensio (si no es una taula, es 0). */
	private int dimension;
	/**  Modificadors que afecten a la visibilitat, poden ser: PUBLIC,PRIVATE,METODE_CLASSE. */	
	private int accesMode;
	
	/** Constructor per defecte: Inicialitza els valors */
	public ParamInfo()
	{
		name=""; text=""; className="";
		type=0;	idType=0; dimension=0;
		accesMode=0; superClassName=null;
	}
	
	/** Especifica el tipus que emmagatzema */
	public void setType(int val)
	{	type=val;	}
	/** Retorna el tipus que emmagatzema */
	public int getType()
	{	return type;	}
	/** Especifica el tipus de ID */
	public void setIdType(int val)
	{	idType=val;	}
	/** Retorna el tipus de ID */
	public int getIdType()
	{	return idType;	}
	/** Especifica la dimensio */
	public void setDimension(int val)
	{	dimension=val;	}
	/** Retorna la dimensio */
	public int getDimension()
	{	return dimension;	}
	/** Especifica el modificador d'acces */
	public void setAccesMode(int val)
	{	accesMode=val;	}
	/** Retorna el modificador d'acces */
	public int getAccesMode()
	{	return accesMode;	}
	/** Incrementa la dimensio */
	public void incDimension()
	{ dimension++; }
	/** Decrementa la dimensio */
	public void decDimension()
	{ dimension--; }
	/** Especifica el nom */
	public void setName(String val)
	{	name=val;	}
	/** Retorna el nom */
	public String getName()
	{	return name;	}
	/** Especifica el nom de la classe */
	public void setClassName(String val)
	{	className=val;	}
	/** Retorna el nom de la classe */
	public String getClassName()
	{	return className;	}
	/** Especifica el nom de la superclasse */
	public void setSuperClassName(String val)
	{	superClassName=val;	}
	/** Retorna el nom de la superclasse */
	public String getSuperClassName()
	{	return superClassName;	}
	/** Especifica el text parsejat */
	public void setText(String val)
	{	text=val;	}
	/** Retorna el text parsejat */
	public String getText()
	{	return text;	}
	/** Concatena el text passat per parametre al que ja teniem emmagatzemat */
	public void appendText(String val)
	{ text=text+val; }
}
