/*  TNode, node de informacio de la TS.
 *  Autor: Carles Royan Salvatella
 *  Ultima modificacio: 18/06/2003
 */

import java.util.Hashtable;
/**
 * <p>Classe que conte la informacio que es desa de cada token en la taula
 * de simbols.
 * </p>
 * @author Carles Royan Salvatella
 * @version 1.0 - Data: 18/06/2003
 */
class TNode
{
	/** Tipus de la variable (ENTER,REAL,..) */
	protected int ttype;
	/** Utilitzat per el nom de la classe */
	protected String text;
	/** Parametres de la funcio */
	protected ParamInfo[] funcParams = null;
	/** Numero de parametres de la funcio */
	protected int numParams;
	/** Numero de dimensions del Id (si no es cap taula, es igual a 0) */
	protected int dimension=0;
	/** Modificador d'acces (public, privat,...) */
	protected int accesMode;
	/** Tipus de identificador (ACCIO, FUNCIO,..) */
	protected int idType;
	/** Interficie de la classe (idType==CLASS_DEF) */
	protected Hashtable classInterface = null;
	/** Si el es una definicio de classe (idType==CLASS_DEF),
	    es guarda la superclasse d'aquesta.
	*/
	private String superClass;
	/** Especifica si el metode esta implementat. */
	private boolean isImplemented = false;
	
  	/** Especifica el nom de la superclasse */
	public void setSuperClassName(String className)
	{
 	superClass=className;
	}
	/** Retorna el nom de la superclasse */
	public String getSuperClassName()
	{
 	return superClass;
	}
	/** Retorna el tipus de variable */
	public int getType() { return ttype; }
	/** Especifica el tipus de variable */
	public void setType(int ttype_)
	{ 
 	ttype = ttype_; 
	}
	/** Retorna el tipus d'identificador (ACCIO, FUNCIO,...) */
	public int getIdType()
	{ return idType; }
	/** Especifica el tipus d'identificador (ACCIO, FUNCIO,...) */
	public void setIdType(int val)
	{ idType=val; }
	/** Retorna el nom de la classe del token */
	public String getText() { return text; }
	/** Especifica el nom de la classe */
	public void setText(String text_)
	{ 
	text = text_; 
	}
	/** Especifica la dimensio (si no es cap taula, es 0) */
	public void setDimension(int val)
	{ dimension=val; }
	/** Retorna la dimensio */
	public int getDimension()
	{ return dimension; }
	/** Especifica el modificador d'acces */	
	public void setAccesMode(int val)
	{ accesMode=val; }
	/** Retorna el modificador d'acces */
	public int getAccesMode()
	{ return accesMode; }
	/** Especifica el numero de parametres */
	public void setNumParams(int val)
	{	numParams=val;	}
	/** Retorna el numero de parametres */
	public int getNumParams()
	{	return numParams;	}
	/** Especifica els parametres de la funcio */
	public void setParamInfo(ParamInfo[] params)
	{	funcParams=params;	}
	/** Retorna els parametres de la funcio */
	public ParamInfo[] getParamInfo()
	{	return funcParams;	}
	/** Especifica la interficie de la classe */
	public void setClassInterface(Hashtable val)
	{	classInterface=val; }
	/** Retorna la interficie de la classe */
	public Hashtable getClassInterface()
	{	return classInterface; }
	/** Especifica si el metode esta implementat */
	public void setIsImplemented(boolean val)
	{ isImplemented=val; }
	/** Retorna si el metode esta implementat */
	public boolean getIsImplemented()
	{ return isImplemented; }

}
