/*  Classe d'entrada/sortida
 *  Autor: Carles Royan Salvatella.
 *  Ultima modificacio: 18/06/2003
 *  Versio: 1.0
 */
import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * <p>Classe d'entrada i sortida que s'utiliza per
 * les instruccions d'E/S del pseudocodi: escriure,escriureln i llegir.
 * </p>
 * @author Carles Royan Salvatella
 * @version 1.0 - Data: 18/06/2003
 */

class _________InputOutput
{
	/** Buffer per el qual es llegeix el teclat */
	private static BufferedReader input;
	/** Cadena auxiliar que conte el que s'ha llegit del teclat */
	private static String aux;
	/** Indica si el buffer esta buit i cal tornar a llegir de nou el teclat */
	private boolean reLlegir=true;
	
	/** Constructor per defecte, crea les classes d'entrada de dades */
	public _________InputOutput()
	{
		input=new BufferedReader(new InputStreamReader(System.in));
	}
	/** Instruccio de llegir: Llegeix una linia de l'entrada estandard */
	private void llegir()
	{
		try
		{
			aux=input.readLine();
		}
		catch (Exception e) { }
	}
	/** Instruccio escriure: escriu un enter per la sortida estandard */
	public void escriure(int val)
	{
		System.out.print(val);
		System.out.flush();        /* Provocant la sortida */
	}
	/** Instruccio escriure: escriu un real per la sortida estandard */	
	public void escriure(double val)
	{
		System.out.print(val);
		System.out.flush();
	}
	/** Instruccio escriure: escriu un boolea per la sortida estandard */	
	public void escriure(boolean val)
	{
		System.out.print(val);
		System.out.flush();
	}
	/** Instruccio escriure: escriu un caracter per la sortida estandard */	
	public void escriure(char val)
	{
		System.out.print(val);
		System.out.flush();
	}
	/** Instruccio escriure: escriu una classe per la sortida estandard */	
	public void escriure(Object val)
	{
		System.out.print(val);
		System.out.flush();
	}
	/** Instruccio escriure: sense cap parametre, no escriu res. */
	public void escriure()
	{
		// No escriu res
	}
	/** Instruccio escriureln: escriu un enter seguit de salt de linia per la sortida estandard */		
	public void escriureln(int val)
	{
		escriure(val);
		System.out.println();
	}
	/** Instruccio escriureln: escriu un real seguit de salt de linia per la sortida estandard */		
	public void escriureln(double val)
	{
		escriure(val);
		System.out.println();
	}
	/** Instruccio escriureln: escriu un caracter seguit de salt de linia per la sortida estandard */		
	public void escriureln(char val)
	{
		escriure(val);
		System.out.println();
	}
	/** Instruccio escriureln: escriu un boolea seguit de salt de linia per la sortida estandard */		
	public void escriureln(boolean val)
	{
		escriure(val);
		System.out.println();
	}	
	/** Instruccio escriureln: escriu una classe seguida de salt de linia per la sortida estandard */		
	public void escriureln(Object val)
	{
		escriure(val);
		System.out.println();
	}
	/** Instruccio escriureln: sense cap parametre escriu nomes el salt de linia per la sortida estandard */	
	public void escriureln()
	{
		escriure();
		System.out.println();
	}
	/** Llegeix un enter de l'entrada estandard i el retorna */
	public int getEnter()
	{
		int enter=0;
		
		llegir();
		enter=Integer.parseInt(aux);
		
		aux="";
		return enter;
	}
	/** Llegeix un real de l'entrada estandard i el retorna */	
	public double getReal()
	{
		double real=0.0;
		
		llegir();
		real=Double.parseDouble(aux);
		
		aux="";
		return real;
	}
	/** Llegeix un boolea de l'entrada estandard i el retorna */	
	public boolean getBoolea()
	{
		boolean boolea=false;
		
		llegir();
		boolea=new Boolean(aux).booleanValue();
		
		aux="";
		return boolea;
	}
	/** Llegeix un caracter de l'entrada estandard i el retorna */	
	public char getCaracter()
	{
		char car=' ';
		
		if (reLlegir)
		{
			llegir();
			reLlegir=false;
		}		
		if (aux.length()==0)
		{
			car='\n';
			reLlegir=true;
		}
		else
		{		
			car=aux.charAt(0);
			aux=aux.substring(1);
		}

		return car;
	}
}
